Package: bcp
Type: Package
Title: Bayesian Analysis of Change Point Problems
Version: 4.0.4
Date: 2026-05-12
Authors@R: c(person(given = "Xiaofei",
                        family = "Wang",
                        role =  "aut" ),
                 person(given = "Chandra",
                        family = "Erdman",
                        role = "aut"),
                 person(given = c("John", "W."),
                        family = "Emerson",
                        role = "aut"),
                 person(given = "Kaiguang",
                        family = "Zhao",
                        role = c("aut", "cre"),
                        email = "zhao.1423@osu.edu")
 			)
Depends: graphics, methods, grid
Suggests: DNAcopy, coda, strucchange, vegan, ggplot2, igraph
Description: Provides an implementation of the product partition model described in Barry and Hartigan (2019) <doi:10.2307/2290726> for the normal errors change point problem using Markov Chain Monte Carlo (MCMC). It also extends the methodology to regression models on a connected graph as reported in Wang and Emerson (2015) <doi:10.48550/arXiv.1509.00817>, allowing estimation of change point models with multivariate responses. Parallel MCMC, previously available in 'bcp' v.3.0.0, is currently not implemented.
License: GPL (>= 2)
Imports: Rcpp (>= 0.11.0)
LinkingTo: Rcpp, RcppArmadillo
LazyData: true
LazyLoad: true
NeedsCompilation: yes
URL: https://github.com/zhaokg/bcp
BugReports: https://github.com/zhaokg/bcp/issues
Repository: CRAN
Encoding: UTF-8
Packaged: 2026-05-16 02:23:03 UTC; zhaokg
Author: Xiaofei Wang [aut],
  Chandra Erdman [aut],
  John W. Emerson [aut],
  Kaiguang Zhao [aut, cre]
Maintainer: Kaiguang Zhao <zhao.1423@osu.edu>
Date/Publication: 2026-05-20 08:50:10 UTC
Built: R 4.5.2; aarch64-apple-darwin20; 2026-05-20 21:40:50 UTC; unix
Archs: bcp.so.dSYM

Package: bcp
Type: Package
Title: Bayesian Analysis of Change Point Problems
Version: 4.0.4
Date: 2026-05-12
Authors@R: c(person(given = "Xiaofei",
                        family = "Wang",
                        role =  "aut" ),
                 person(given = "Chandra",
                        family = "Erdman",
                        role = "aut"),
                 person(given = c("John", "W."),
                        family = "Emerson",
                        role = "aut"),
                 person(given = "Kaiguang",
                        family = "Zhao",
                        role = c("aut", "cre"),
                        email = "zhao.1423@osu.edu")
 			)
Depends: graphics, methods, grid
Suggests: DNAcopy, coda, strucchange, vegan, ggplot2, igraph
Description: Provides an implementation of the product partition model described in Barry and Hartigan (2019) <doi:10.2307/2290726> for the normal errors change point problem using Markov Chain Monte Carlo (MCMC). It also extends the methodology to regression models on a connected graph as reported in Wang and Emerson (2015) <doi:10.48550/arXiv.1509.00817>, allowing estimation of change point models with multivariate responses. Parallel MCMC, previously available in 'bcp' v.3.0.0, is currently not implemented.
License: GPL (>= 2)
Imports: Rcpp (>= 0.11.0)
LinkingTo: Rcpp, RcppArmadillo
LazyData: true
LazyLoad: true
NeedsCompilation: yes
URL: https://github.com/zhaokg/bcp
BugReports: https://github.com/zhaokg/bcp/issues
Repository: CRAN
Encoding: UTF-8
Packaged: 2026-05-16 02:23:03 UTC; zhaokg
Author: Xiaofei Wang [aut],
  Chandra Erdman [aut],
  John W. Emerson [aut],
  Kaiguang Zhao [aut, cre]
Maintainer: Kaiguang Zhao <zhao.1423@osu.edu>
Date/Publication: 2026-05-20 08:50:10 UTC

# bcp
`bcp` is an R package that provides an implementation of the Barry and Hartigan (1993) product partition model for the normal errors change point problem using Markov Chain Monte Carlo.  It also extends the methodology to regression models on a connected graph (Wang and Emerson, 2015); this allows estimation of change point models with multivariate responses. Parallel MCMC, previously available in bcp v.3.0.0, is currently not implemented.

To install:

* the latest released version: `install.packages("bcp")`
* the latest development version: `install_github("zhaokg/bcp")`

#' Bayesian Analysis of Change Point Problems
#' 
#' Provides an implementation of the Barry and Hartigan (1993) product partition model for the normal errors change point problem using Markov Chain Monte Carlo.  It also (i) extends the methodology to regression models on a connected graph (Wang and Emerson, 2015) and (ii) allows estimation of change point models with multivariate responses. Parallel MCMC, previously available in bcp v.3.0.0, is currently not implemented.
#' @docType package
#' @name bcp-package
#' @author Xiaofei Wang, Chandra Erdman, and John W. Emerson
#' @import methods grid  
#' @importFrom Rcpp evalCpp
#' @useDynLib bcp
NULL

data(NewHavenHousing)

if ( require("vegan") &  require("ggplot2") ) {

findNeighborsMST <- function(x) {
     #  library(vegan)  
	  adj <- cbind(x$Long, x$Lat)
	  adj <- spantree(vegdist(adj, "euclidean"))


	  adj2 <- vector('list', nrow(x))
	  for (i in 2:nrow(x)) {
		adj2[[i]] <- c(adj2[[i]], adj$kid[i-1]-1)
	  }
	  #make neighborhood structure symmetric
	  for (i in 1:nrow(x)) {
		for (j in (adj2[[i]]+1)) {
		  adj2[[j]] <- unique(c(adj2[[j]], i-1))
		}
	  }
	  return(adj2)  
}


modalBlock <- function(parts, ignoreNodes = NULL, silent = TRUE) {
  if (!is.null(ignoreNodes)) parts <- parts[,-ignoreNodes]
  parts <- apply(parts, 1, function(x) paste(match(x,unique(x))-1, collapse=","))
  tbl <- table(parts)
  dist <- as.numeric(sort(tbl, decreasing=TRUE))
  if (max(tbl) != 1) {
    mode <- names(tbl)[which(tbl==max(tbl))]
    mode <- strsplit(mode,",")
    if (!silent) cat("Modal partition hit ", max(tbl), "times.\n")
    if (length(mode) > 1) {
      print("More than 1 mode!")
      return(list(mode=mode, distr=dist))
    } else {
      return(list(mode=as.numeric(unlist(mode)), 
                  distr=dist))
    }
  }
}
plotModalBlockMap <- function(block, ignoreNodes = NULL, x, title=NULL) {
  if (!is.null(ignoreNodes)) {
    dat1 <- data.frame(Longitude = x$Long[ignoreNodes], Latitude = x$Lat[ignoreNodes])
    x <- x[-ignoreNodes,]
  }
  dat2 <- data.frame(logval = log(x$CurVal),
                   sqrtLivingArea = sqrt(x$LivingArea),
                   beds = x$TotalBedrooms,
                   size = x$size, Longitude = x$Long, Latitude = x$Lat, block = as.factor(block))
  p <- ggplot(dat2, aes(y=Latitude, x = Longitude)) +
    geom_text(aes(label = block, color=block, fontface="bold"), size=10) +
    ylim(c(41.3279, 41.333))
  if (!is.null(ignoreNodes))  
    p <- p + geom_point(data=dat1, aes(y=Latitude, x= Longitude), size=10)
  p <- p + theme(legend.position="none") + ggtitle(title)
  return(p)
}

plotResiduals <- function(yhat, x, membs = NULL, ylim=NULL) {
  resids <- log(x$CurVal) - yhat
  dat <- data.frame(Residuals = resids,
                    block = as.character(membs), 
                    Latitude = x$Lat,
                    Longitude = x$Long)
  p <- ggplot(dat, aes(y=Residuals, x = Longitude)) +
        geom_point(aes(color = block), size=4) + ylim(ylim[1], ylim[2])+
        theme(legend.position="none")
  print(p)
}

adj  <- findNeighborsMST(NewHavenHousing)
dat2 <- data.frame(logval = log(NewHavenHousing$CurVal),
                   sqrtLivingArea = sqrt(NewHavenHousing$LivingArea),
                   beds = NewHavenHousing$TotalBedrooms,
                   size = NewHavenHousing$size)

# plot all houses
plot(NewHavenHousing$Long, NewHavenHousing$Lat, cex=(log(NewHavenHousing$CurVal)-11)/1.2*2, xlab="Longitude",     
     ylab="Latitude", ylim=c(41.3279, 41.333))
for (i in 1:length(adj)) {
  for (j in 1:length(adj[[i]]))
   segments(NewHavenHousing$Long[i], NewHavenHousing$Lat[i], 
            NewHavenHousing$Long[adj[[i]][j]+1], NewHavenHousing$Lat[adj[[i]][j]+1])
}
a <- c(-72.931, 41.333)
b <- c(-72.9171, 41.3300)
c <- c(-72.932, 41.331)
d <- c(-72.9174, 41.3279)
segments(a[1], a[2], b[1], b[2], lty=2)
segments(a[1], a[2], c[1],c[2], lty=2)
segments(b[1],b[2],d[1],d[2], lty=2)
segments(c[1],c[2],d[1],d[2], lty=2)


z <- cbind(1, as.matrix(dat2[,-1]))

set.seed(5)
tmp <- bcp(dat2$logval, z, NULL, adj, 
          w0=rep(0.2, 4), boundaryType="node", 
          p0 = 0.1, mcmc = 1000, burnin=1000, 
          p1=0, freqAPP=20, return.mcmc=TRUE)
blocks <- modalBlock(t(tmp$mcmc.rhos[,-(1:1000)]))$mode

#library(ggplot2)
plotModalBlockMap(blocks+1, x=NewHavenHousing)


lm.1 <- lm(logval ~ ., dat2)
f1 <- lm.1$fitted
f2 <- tmp$posterior.mean[,1]

dat2$neighborhood <- factor(blocks)
lm.2 <- lm(logval ~ ., dat2)
f3 <- lm.2$fitted

minMax <- range(c(dat2$logval-f1, dat2$logval-f2, 
                  dat2$logval-f3))

plotResiduals(f1, NewHavenHousing, blocks, ylim=minMax)
plotResiduals(f2, NewHavenHousing, blocks, ylim=minMax)
plotResiduals(f3, NewHavenHousing, blocks, ylim=minMax)



}

#' @title Summarizing Bayesian change point analysis results
#' @description
#' Summary and print methods for class \code{bcp}.
#'
#' @param x the result of a call to \code{bcp()}.
#' @param object the result of a call to \code{bcp()}.
#' @param digits the number of digits displayed in the summary statistics.
#' @param ... (optional) additional arguments, ignored.
#' 
#' @author Xiaofei Wang, Chandra Erdman, and John W. Emerson
#' @return 
#' The matrix of results is returned invisibly.
#' @details 
#' The functions print (and return invisibly) the estimated posterior probability of a change point for each position and the estimated posterior means. These results are modeled after the summary method of the \code{coda} package (Plummer \emph{et al.}, 2006). If \code{return.mcmc=TRUE} (i.e., if full MCMC results are returned), \code{bcp} objects can be converted into \code{mcmc} objects to view \code{mcmc} summaries -- see examples below.
#' @seealso \code{\link{bcp}} and \code{\link{plot.bcp}}.
#' @examples 
#' ##### A random sample from a few normal distributions #####
#' testdata <- c(rnorm(50), rnorm(50, 5, 1), rnorm(50))
#' bcp.0 <- bcp(testdata)
#' summary(bcp.0)
#' plot(bcp.0, main="Univariate Change Point Example")
#' 
#' ##### An MCMC summary from the ``coda'' package #####
#' \dontrun{
#' if (require("coda")) {
#'   bcp.0 <- bcp(testdata, return.mcmc=TRUE)
#'   bcp.mcmc <- as.mcmc(t(bcp.0$mcmc.means))
#'   summary(bcp.mcmc)
#'   heidel.diag(bcp.mcmc) # an example convergence diagnostic
#'   # from the coda package.
#' }
#' }
#' @keywords datasets
#' @export
summary.bcp <-
  function (object, digits = max(3, .Options$digits - 3), ...) {
  
  if (is.null(colnames(object$data))) {
    colnames(object$data) <- c("Loc", paste(rep("X", ncol(object$data)-1), 
                                   1:(ncol(object$data)-1), sep=""))
  }

  statnames <- c("Probability", colnames(object$posterior.mean))
  varstats <- matrix(NA, nrow = max(object$data[,1]), 
                     ncol = length(statnames), 
                     dimnames = list(1:max(object$data[,1]), statnames))
						   
  varstats[,1] <- object$posterior.prob
  varstats[,2:ncol(varstats)] <- object$posterior.mean

  cat("\nBayesian Change Point (bcp) summary:\n\n")
  cat("\nProbability of a change in mean and posterior means:\n\n")
  print(varstats, digits=digits)
  cat("\n")

  invisible(varstats)
}

#' @rdname summary.bcp
#' @export
print.bcp <- function(x, digits = max(3, .Options$digits - 3), ...) {
  summary(x, digits=digits, ...)
}
#' @title Estimate the probability of a change point in a specified interval
#' 
#' @description
#' The function \code{interval.prob()} estimates the probability of at least one
#' change point in the specified interval of sequential observations; it may only be used when \code{return.mcmc=TRUE}.
#'
#' @param object the result of a call to \code{bcp()}.
#' @param start the starting index of the interval.
#' @param end the ending index of the interval.
#' 
#' @author Xiaofei Wang, Chandra Erdman, and John W. Emerson
#' @details For sequential data only, the function returns an estimate of the posterior probability of at least one change point in the specified interval.
#' @note \code{return.mcmc} must be \code{TRUE}.
#' @seealso \code{\link{bcp}} and \code{\link{plot.bcp}}.
#' @examples 
#' ##### A random sample from a few normal distributions #####
#' testdata <- c(rnorm(50), rnorm(50, 5, 1), rnorm(50))
#' bcp.0 <- bcp(testdata, return.mcmc=TRUE)
#' plot(bcp.0, main="Univariate Change Point Example")
#' interval.prob(bcp.0, 45, 55)
#' 
#' @keywords datasets
#' @export	
interval.prob <- function(object, start, end) {
  if (attr(object, "structure") == "graph") stop("Method is not implemented for graph change points.")
  if (!object$return.mcmc) stop("bcp must be run with return.mcmc=TRUE")
  return( sum(apply(object$mcmc.rhos[start:end,-c(1:object$burnin)], 2, sum) > 0) /
          object$mcmc)
}

#' @title Plotting univariate Bayesian change point results
#' @aliases legacyplot
#' @description
#' \code{legacyplot()} produces summary plots of the results of \code{bcp()} when used for univariate analysis; it was the default method prior to package version 3.0.0.
#' @param x the result of a call to \code{bcp()}.
#' @param ... (optional) additional arguments, ignored.
#' 
#' @author Chandra Erdman and John W. Emerson
#' @details \code{legacyplot()} produces the following plots using \code{base} graphics:
#'
#' Posterior Means: location in the sequence versus the posterior mean over the iterations. 
#' 
#' Posterior Probability of a Change: location in the sequence versus the relative frequency of iterations which resulted in a change point. 
#' 
#' @seealso \code{\link{plot.bcp}}, \code{\link{bcp}}, \code{\link{summary.bcp}}, and \code{\link{print.bcp}} for complete results and summary statistics.
#' @examples 
#' ##### A random sample from a few normal distributions #####
#' testdata <- c(rnorm(50), rnorm(50, 5, 1), rnorm(50))
#' bcp.0 <- bcp(testdata, return.mcmc=TRUE)
#' legacyplot(bcp.0)
#' 
#' @keywords datasets
#' @export
legacyplot <- function(x, ...) { 	
  if ((is.matrix(x$data) && ncol(x$data)>2 ) && 
       !(attr(x, "model") == "multivariate" || attr(x, "structure") == "series"))
    stop("Legacy bcp plot invalid for multivariate bcp object or graph bcp object.")
  posterior.prob <- x$posterior.prob
  posterior.prob[length(posterior.prob)] <- 0
		
  op <- par(mfrow=c(2,1),col.lab="black",col.main="black")
  op2 <- par(mar=c(0,4,4,2),xaxt="n", cex.axis=0.75)
  plot(1:nrow(x$data), x$data[,2], col="grey", 
       pch=20, xlab="", ylab="Posterior Mean", 
       main="Posterior Means and Probabilities of a Change", ...)
  lines(x$posterior.mean, lwd=2)
  par(op2)
  op3 <- par(mar=c(5,4,0,2), xaxt="s", cex.axis=0.75)
  plot(1:length(x$posterior.mean), posterior.prob, 
       yaxt="n", type="l", ylim=c(0,1),
       xlab="Location", ylab="Posterior Probability", main="")
  axis(2, yaxp=c(0, 0.9, 3))
  par(op3)
  par(op)
  return(NULL)
}

#' @title Plotting Bayesian change point results
#' 
#' @description
#' \code{plot.bcp()} produces summary plots of the results of \code{bcp()}. Currently, only the summary plots for serial data are implemented. 
#' If an adjacency structure (adj) is provided, then the data are assumed to reside on nodes of a general graph. Additional parameters are used in this graph change point model.
#'
#' @details 
#' \code{plot.bcp()} produces the following plots using \code{grid} graphics instead of \code{base}:
#'   
#'  Posterior Means: location in the sequence versus the posterior means over the iterations. 
#' 
#'  Posterior Probability of a Change: location in the sequence versus the relative frequency of iterations which resulted in a change point. 
#' 
#' @param x the result of a call to \code{bcp()}.
#' @param separated logical. If set to \code{TRUE} and the data is multivariate, each series is plotted separately.
#' @param outer.margins (optional) list of units specifying the left, bottom, right and top margins.  For more information on units, see the documentation for \code{grid}.
#' @param lower.area (optional) unit specifying the proportion of the plot occupied by the posterior probabilities of change points.
#' @param size.points (optional) unit specifying the size of the data points.
#' @param pch.points (optional) unit specifying the style of the data points.
#' @param colors (optional) vector specifying the colors in which to plot each data series.
#' @param main (optional) plot title. Use \code{""} for no title.
#' @param xlab (optional) a character string specifying the x-axis label. Defaults to "Location".
#' @param xaxlab (optional) a vector having length equal to the number of observations giving the x-axis tick labels. Defaults to the sequence from 1 to n.
#' @param cex.axes (optional) list specifying the sizes of the axes labels. \code{cex.xaxis} specifies the size of the x-axis label, \code{cex.yaxis.lower} specifies the size of the y-axis label of the posterior probability plot, \code{cex.yaxis.upper.default} specifies the size of the y-axis labels of the posterior means plot when the series are displayed in a single plot, and \code{cex.yaxis.upper.separated} specifies the size of the y-axis labels of the posterior means plots when each series is plotted separately.
#' @param lwd line width
#' @param ... (optional) additional arguments, ignored.
#' 
#' @author Xiaofei Wang, Chandra Erdman, and John W. Emerson
#' 
#' @seealso \code{\link{legacyplot}}, \code{\link{bcp}}, \code{\link{summary.bcp}}, and \code{\link{print.bcp}} for complete results and summary statistics.
#' @examples 
#' testdata <- cbind( c(rnorm(50), rnorm(50, -5, 1), rnorm(50)),
#' c(rnorm(50), rnorm(50, 10.8, 1), rnorm(50, -3, 1)) )
#' bcp.0 <- bcp(testdata)
#' plot(bcp.0, main="Multivariate (k=2) Change Point Example")
#' plot(bcp.0, separated=TRUE, main="Multivariate (k=2) Change Point Example")
#' 
#' @keywords datasets
#' @export
plot.bcp <- function(x, separated = FALSE, 
                     outer.margins = list(left=unit(4, "lines"),
                                          bottom=unit(3, "lines"),
                                          right=unit(2, "lines"), 
                                          top=unit(2, "lines")),
                     lower.area = unit(0.33, "npc"),
                     size.points = unit(0.25, "char"),
                     pch.points = 20,
                     colors = NULL,
                     main = NULL,
                     xlab = NULL,
                     xaxlab = NULL,
                     cex.axes = list(cex.xaxis = 0.75,
                                     cex.yaxis.lower = 0.75,
                                     cex.yaxis.upper.default = 0.75,
                                     cex.yaxis.upper.separated = 0.5), lwd=1,
                     ...) {
  # if (!require(grid)) stop("library(grid) is required and unavailable.\n\n")
  if (attr(x, "structure") == "graph")   
    stop("Plotting functionality for data on a graph has not yet been implemented.")

  grid.newpage()

  thisjust <- c("left", "bottom")
  n <- length(x$posterior.prob)
  if (!is.matrix(x$data)) {
    x$data <- matrix(x$data, ncol=1) 
    x$posterior.mean <- matrix(x$posterior.mean, ncol=1)
  }
  m <- ncol(x$data)
  if (is.null(colors)) {
    colors <- 2:(m+1)
  } else {
    if (length(colors)!=m) stop("length(colors) must equal number of series.")
  }
  if (is.null(main)) main <- "Posterior Means and Probabilities of a Change"
  if (is.null(xlab)) xlab <- "Location"
  
  vp.main <- viewport(x=outer.margins$left, y=outer.margins$bottom,
                      width=unit(1, "npc")-outer.margins$right-outer.margins$left,
                      height=unit(1, "npc")-outer.margins$top-outer.margins$bottom,
                      just=thisjust, name="main", clip="off")
  pushViewport(vp.main)
  grid.rect()
  grid.text(main, 0.5, unit(1, "npc")+unit(1,"lines"), 
            gp=gpar(fontface="bold"))

  # Upper plot
  if (attr(x, "model") == "multivariate") {
    if (!separated) {
      pushViewport(viewport(x=unit(0, "npc"), y=lower.area,
                            width=unit(1, "npc"), height=unit(1, "npc") - lower.area,
                            just=thisjust, name="upper", clip="off",
                            default.units="native",
                            xscale=range(pretty(x$data[,1])),
                            yscale=range(pretty(x$data[,-1], n=10))))
      grid.rect()
      grid.yaxis(gp=gpar(cex=cex.axes$cex.yaxis.upper.default), main=FALSE)
      grid.text("Posterior Means", unit(-3, "lines"), 0.5, rot=90)
      for (i in 2:m) {
        grid.points(x$data[,1], x$data[,i], size=size.points, gp=gpar(col=colors[i]-1),
                    pch=pch.points)
        grid.lines(unique(x$data[,1]), x$posterior.mean[,i-1], gp=gpar(col=colors[i]-1, lwd=lwd),
                   default.units="native")
      }
      popViewport(1)
    } else {
      pushViewport(viewport(x=unit(0, "npc"), y=lower.area,
                            width=unit(1, "npc"), height=unit(1, "npc") - lower.area,
                            just=thisjust, name="upper", clip="off"))
      grid.text("Posterior Means", unit(-3, "lines"), 0.5, rot=90)
      yloc <- FALSE
      for (i in 2:m) {
        pushViewport(viewport(x=unit(0, "npc"),
                              y=unit((i-1)/m, "npc"),
                              width=unit(1, "npc"),
                              height=unit(1/m, "npc"),
                              just=thisjust, name="upper", clip="off",
                              default.units="native",
                              xscale=range(pretty(x$data[,1])),
                              yscale=range(pretty(x$data[,i]))))
        grid.rect()
        grid.yaxis(gp=gpar(cex=cex.axes$cex.yaxis.upper.separated), main=yloc)
        grid.points(x$data[,1], x$data[,i], size=size.points, gp=gpar(col=colors[i]-1),
                    pch=pch.points)
        grid.lines(unique(x$data[,1]), x$posterior.mean[,i-1], gp=gpar(col=colors[i]-1, lwd=lwd),
                      default.units="native")
        popViewport(1)
        yloc <- !yloc
      }
      popViewport(1)
    }
  } else {
    if (!separated) {
      pushViewport(viewport(x=unit(0, "npc"), y=lower.area,
                            width=unit(1, "npc"), height=unit(1, "npc") - lower.area,
                            just=thisjust, name="upper", clip="off",
                            default.units="native",
                            xscale=range(pretty(x$data[,1])),
                            yscale=range(pretty(x$data[,2]))))
      grid.rect()
      grid.yaxis(gp=gpar(cex=cex.axes$cex.yaxis.upper.default), main=FALSE)
      grid.text("Posterior Means", unit(-3, "lines"), 0.5, rot=90)
  #    for (i in 1:m) {
        grid.points(x$data[,1], x$data[,2], size=size.points, gp=gpar(col=colors[1]),
                    pch=pch.points)
        grid.lines(1:n, x$posterior.mean[,1], gp=gpar(col=colors[1], lwd=lwd),
                   default.units="native")
  #    }
      popViewport(1)
    } else {
      pushViewport(viewport(x=unit(0, "npc"), y=lower.area,
                            width=unit(1, "npc"), height=unit(1, "npc") - lower.area,
                            just=thisjust, name="upper", clip="off"))
      grid.text("Posterior Means", unit(-3, "lines"), 0.5, rot=90)
      yloc <- TRUE
      m <- m - 1
      for (i in 2:(m+1)) {
        pushViewport(viewport(x=unit(0, "npc"),
                              y=unit((m-i+1)/m, "npc"),
                              width=unit(1, "npc"),
                              height=unit(1/m, "npc"),
                              just=thisjust, name="upper", clip="off",
                              default.units="native",
                              xscale=range(pretty(x$data[,1])),
                              yscale=range(pretty(x$posterior.mean[,i]))))
        grid.rect()
        grid.yaxis(gp=gpar(cex=cex.axes$cex.yaxis.upper.separated), main=yloc)
        if (yloc) {
          grid.text(colnames(x$posterior.mean)[i], x=unit(-2, "lines"), rot=90, gp=gpar(cex.xaxis=0.5))
        } else {
          grid.text(colnames(x$posterior.mean)[i], x=1.05, rot=90, gp=gpar(cex.xaxis=0.5))
        }

        grid.points(unique(x$data[,1]), x$posterior.mean[,i], size=size.points, gp=gpar(col=colors[1]),
                    pch=pch.points)
        grid.lines(unique(x$data[,1]), x$posterior.mean[,i], gp=gpar(col=colors[1], lwd=lwd),
                      default.units="native")
        popViewport(1)
        yloc <- !yloc
      }
      popViewport(1)
    }
  }

  # Lower plot
  pushViewport(viewport(x=unit(0, "npc"), y=unit(0, "npc"),
                        width=unit(1, "npc"), height=lower.area,
                        just=thisjust, name="lower", clip="off",
                        default.units="native",
                        xscale=range(pretty(x$data[,1])),
                        yscale=c(-0.05, 1.05)))
  grid.rect()
  grid.yaxis(gp=gpar(cex=cex.axes$cex.yaxis.lower))
  if (!is.null(xaxlab)) {
    grid.xaxis(at = 1:n, label=xaxlab, gp=gpar(cex=cex.axes$cex.xaxis))
  } else grid.xaxis(gp=gpar(cex=cex.axes$cex.xaxis))
  grid.text("Posterior Probability", unit(-3, "lines"), 0.5, rot=90)
  grid.text(xlab, 0.5, unit(-2, "lines"))
  grid.lines(1:max(x$data[,1]), x$posterior.prob, default.units="native", gp = gpar(lwd=lwd))
  popViewport(2) # vp.main and vp.lower

}

#' @title Extract model residuals
#' 
#' @description
#' residuals method for class \code{bcp}.
#'
#' @param object the result of a call to \code{bcp()}.
#' @param ... (optional) additional arguments, ignored.
#' 
#' @author Xiaofei Wang, Chandra Erdman, and John W. Emerson
#' @return 
#' Residuals extracted from the \code{bcp} object.
#' @seealso \code{\link{bcp}} and \code{\link{plot.bcp}}
#' @examples 
#' ##### A random sample from a few normal distributions #####
#' testdata <- c(rnorm(50), rnorm(50, 5, 1), rnorm(50))
#' bcp.0 <- bcp(testdata)
#' residuals(bcp.0)
#' 
#' @keywords datasets
#' @export
residuals.bcp <- function(object, ...) { 
  if (attr(object, "model") == "multivariate")
    return(object$data[,-1] - fitted.bcp(object))
  else 
    return(object$data[,2] - fitted.bcp(object))
}
#' @title Extract model fitted values
#' 
#' @description
#' fitted method for class \code{bcp}.
#'
#' @param object the result of a call to \code{bcp()}.
#' @param ... (optional) additional arguments, ignored.
#' 
#' @author Xiaofei Wang, Chandra Erdman and John W. Emerson
#' @return 
#' Fitted values extracted from the \code{bcp} object.
#' @seealso \code{\link{plot.bcp}}, \code{\link{summary.bcp}}, and \code{\link{print.bcp}} for summaries of the results.
#' @examples 
#' ##### A random sample from a few normal distributions #####
#' testdata <- c(rnorm(50), rnorm(50, 5, 1), rnorm(50))
#' bcp.0 <- bcp(testdata)
#' residuals(bcp.0)
#' 
#' @keywords datasets
#' @export
fitted.bcp <- function(object, ...) {
  if (attr(object, "model") == "multivariate")
    return(object$posterior.mean[object$data[,1],])
  else
    return(object$posterior.mean[object$data[,1],1])
}

# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

rcpp_bcpR <- function(py, px, pgrpinds, pid, pmcmcreturn, pburnin, pmcmc, pa, pw, pba, pnreg) {
    .Call('_bcp_rcpp_bcpR', PACKAGE = 'bcp', py, px, pgrpinds, pid, pmcmcreturn, pburnin, pmcmc, pa, pw, pba, pnreg)
}

rcpp_bcpM <- function(pdata, pid, pmcmcreturn, pburnin, pmcmc, pa, pw) {
    .Call('_bcp_rcpp_bcpM', PACKAGE = 'bcp', pdata, pid, pmcmcreturn, pburnin, pmcmc, pa, pw)
}

rcpp_ppm <- function(pdata, pid, padj, pmcmcreturn, pburnin, pmcmc, pa, pc, pmembs, pboundaryType, p1, pfreqAPP) {
    .Call('_bcp_rcpp_ppm', PACKAGE = 'bcp', pdata, pid, padj, pmcmcreturn, pburnin, pmcmc, pa, pc, pmembs, pboundaryType, p1, pfreqAPP)
}

rcpp_ppmR <- function(py, px, pgrpinds, pid, padj, pmcmcreturn, pburnin, pmcmc, pa, pc, pmembs, pboundaryType, pba, p1, pfreqAPP, pnreg) {
    .Call('_bcp_rcpp_ppmR', PACKAGE = 'bcp', py, px, pgrpinds, pid, padj, pmcmcreturn, pburnin, pmcmc, pa, pc, pmembs, pboundaryType, pba, p1, pfreqAPP, pnreg)
}

#' @title Array CGH data set of Coriell cell lines
#' @name coriell
#' @description These are two data array CGH studies of Coriell cell lines taken from the reference below.
#' @docType data
#' @usage coriell
#' @format A data frame containing five variables: first is clone name, second is clone chromosome, third is   clone position, fourth and fifth  are log2ratio for two cell lines.
#' @references 
#' \enumerate{ 
#' \item Olshen, A. B., Venkatraman, E. S., Lucito, R., Wigler, M. (2004), Circular binary segmentation for the analysis of array-based DNA copy number data, \emph{Biostatistics}, \bold{5}, 557-572. url: \url{https://www.bioconductor.org/packages/release/bioc/html/DNAcopy.html}.
#' \item Snijders \emph{et al.} (2001), Assembly of microarrays for genome-wide measurement of DNA copy number, \emph{Nature Genetics}, \bold{29}, 263-264. 
#' }
#' @source \url{ https://www.nature.com/articles/ng754}
#' @keywords datasets
#' @examples 
#' demo(coriell)
#' 
NULL

#' @title Milling machine indentation data
#' @name lombard
#' @format A vector of length 100 containing the individual radii.
#' @docType data
#' @usage lombard
#' @description Radii of 100 circular indentations cut by a milling machine.
#' @references 
#' \enumerate{ 
#' \item Daniel Barry and J. A. Hartigan (1993), A Bayesian Analysis for Change Point Problems, \emph{Journal of The American Statistical Association}, \bold{88}, 309-19.
#' \item F. Lombard (1987), Rank Tests for Changepoint Problems, \emph{Biometrika}, \bold{74}, 615-624. 
#' }
#' @source The data is available online in the data archive of the
#' \emph{Journal of Applied Econometrics}. url: 
#'  \url{http://qed.econ.queensu.ca/jae/2003-v18.1/bai-perron/}.
#' @keywords datasets
#' @examples  
#' \dontrun{
#' data(lombard)
#' # univariate change point analysis
#' bcp.model <- bcp(lombard, burnin=500, mcmc=5000, return.mcmc=TRUE)
#' 
#' # linear model change point analysis 
#' bcpr.model <- bcp(lombard, cbind(1:100), burnin=500, mcmc=5000, return.mcmc=TRUE)
#' 
#' plot(bcp.model, main="Lombard Milling Data")
#' plot(bcpr.model, main="Lombard Milling Data (with Regression Model)")
#' }
NULL


#' @title New Haven housing data
#' @name NewHavenHousing
#' @format A matrix containing location, 2011 assessed value, and physical characteristics in the columns.
#' @docType data
#' @usage NewHavenHousing
#' @description Location, 2011 assessed value, and physical characteristics for 244 houses in a region of New Haven, CT.
#' @source The data can be scraped from the New Haven, CT Online Assessment Database \url{https://gis.vgsi.com/newhavenct/}
#' @references 
#' Xiaofei Wang and John W. Emerson (2015). Bayesian Change Point Analysis of Linear Models on General Graphs, \emph{Working Paper}.
#' @keywords datasets
#' @examples  
#' \dontrun{
#' demo("NewHaven")
#' }
#' 
NULL


#' @title Quebec river streamflow data
#' @name QuebecRivers
#' @format A matrix containing streamflow amounts for the years 1972 to 1994.
#' @docType data
#' @usage QuebecRivers
#' @description Annual January to June streamflow amounts (measured in \eqn{L/(km^2 s)}) for four rivers in Quebec: Baleine, Churchill Falls, Manicouagan, and Romaine.
#' @source The data can be obtained from the Centre d'expertise hydrique Quebec. \url{https://www.cehq.gouv.qc.ca/hydrometrie/index-en.htm}
#' @references 
#' \enumerate{ 
#' \item Xiaofei Wang and John W. Emerson (2015). Bayesian Change Point Analysis of Linear Models on General Graphs, \emph{Working Paper}.
#' \item L. Perrault \emph{et al.} (2000). Retrospective multivariate Bayesian change-point analysis: a simultaneous single change in the mean of several hydrological sequences, \emph{Stochastic Environmental Research and Risk Assessment}, \bold{14}, 243-261.
#' }
#' @keywords datasets
#' @examples  
#' data("QuebecRivers")
#' bcpr.rivers <- bcp(QuebecRivers)
#' plot(bcpr.rivers, main="Quebec River Streamflow Change Point Analysis", 
#'      xlab="Year", xaxlab = 1972:1994)
#' 
NULL


#' @title US Ex-post Real Interest Rate data, 1961(1):1986(3)
#' @name RealInt
#' @format A quarterly time series from 1961(1) to 1986(3).
#' @docType data
#' @usage RealInt
#' @description US ex-post real interest rate: the three-month treasury bill
#' deflated by the CPI inflation rate.
#' @references 
#' \enumerate{ 
#' \item J. Bai and P. Perron (2003), Computation and Analysis of Multiple Structural Change Models, \emph{Journal of Applied Econometrics}, \bold{18}, 1-22. \url{http://qed.econ.queensu.ca/jae/2003-v18.1/bai-perron/}.
#' \item Achim Zeileis, Friedrich Leisch, Kurt Hornik, Christian Kleiber (2002), strucchange: An R Package for Testing for Structural Change in Linear Regression Models, \emph{Journal of Statistical Software}, \bold{7}(2), 1--38. \url{https://www.jstatsoft.org/v07/i02/}.
#' }
#' @source The data is available online in the data archive of the
#' \emph{Journal of Applied Econometrics}. url: 
#'  \url{http://qed.econ.queensu.ca/jae/2003-v18.1/bai-perron/}.
#' @keywords datasets
#' @examples  
#' demo(RealInt)
#' 
NULL

#
# bcp: an R package for performing a Bayesian analysis
# of change point problems.
#
# Copyright (C) 2011 Chandra Erdman and John W. Emerson
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, a copy is available at
# http://www.r-project.org/Licenses/
#
#-------------------
# FILE: bcp.R

#' @title Performs a Bayesian analysis of change point problems
#' 
#' @description
#' \code{bcp()} implements the Bayesian change point analysis methods given in Wang and Emerson (2015), of which the Barry and Hartigan (1993) product
#' partition model for the normal errors change point problem is a specific case. 1. Multivariate (or univariate) Bayesian change point analysis: We assume there exists an unknown partition of a data series y
#' into blocks such that the mean is constant within each block.  In the multivariate
#' case, a common change point structure
#' is assumed; means are constant within each block of each sequence, but may differ across sequences
#' within a given block. Conditional on the partition, the model assumes that observations are independent, identically distributed normal, with constant means within blocks and
#' constant variance throughout each sequence.  
#' 2. Linear regression Bayesian change point analysis: As with the previous model, we assume the observations (x,y), where x may be multivariate, are partitioned into blocks, and that linear models are appropriate within each block. 
#' 
#' If an adjacency structure is provided, the data are assumed to reside on nodes of a graph with the given adjacency structure; additional parameters are used in this graph change point model. If no adjacency structure is provided, the data are assumed to be sequential and the blocks are forced to be contiguous. 
#'
#' @details 
#' The primary result is an estimate of the posterior mean (or its distribution if
#' \code{return.mcmc} is \code{TRUE}) at every location.  Unlike a frequentist or
#' algorithmic approach to the problem, these estimates will not be constant within
#' regions, and no single partition is identified as best.  Estimates of the
#' probability of a change point at any given location are provided, however.
#' 
#' The user may set \code{.Random.seed} to control the MCMC iterations.
#' 
#' The functions \code{\link{summary.bcp}}, \code{\link{print.bcp}}, and \code{\link{plot.bcp}} are
#' used to obtain summaries of the results; \code{\link{legacyplot}} is included
#' from package versions prior to 3.0.0 and will only work for univariate change
#' point analyses.
#' 
#' @param y a vector or matrix of numerical data (with no missing values). For
#' the multivariate change point problems, each column corresponds to a series.
#' @param x (optional) a matrix of numerical data (with no missing values) representing the predicting variables for a linear regression. 
#' @param id (optional) a vector of integers specifying the location ID for each observation in \code{y}, starting from location 1.
#' @param adj (optional) an adjacency list. Indexing the observations from 1 to \eqn{n}, the \eqn{i}-th element of the list is a vector of indices (offset by 1) for nodes that share an edge with node \eqn{i}.
#' @param w0 (optional) a single numeric value in the multivariate case or a vector of values in the regression case; in both, the value(s), between 0 and 1, is/are the parameter(s) in the uniform prior(s) on the signal-to-noise
#'          ratio(s).  If no value is specified, the default value of 0.2 is used, as    
#'          recommended by Barry and Hartigan (1993).
#' @param p0 (optional) a value between 0 and 1. For sequential data, it is the parameter of the prior on change point probabilities, \eqn{U(0,}\code{ p0}\eqn{)}, on the probability
#'          of a change point at each location in the sequence; for data on a graph, it is the parameter in the partition prior, \code{p0}\eqn{^{l(\rho)}}, where \eqn{l(\rho)} is the boundary length of the partition. 
#' @param d (optional) a positive number only used for linear regression change point models. Lower \code{d} means higher chance of fitting the full linear model (instead of the intercept-only model); see prior for \eqn{\tau_S} in Wang and Emerson (2015).
#' @param burnin the number of burnin iterations.
#' @param mcmc the number of iterations after burnin. 
#' @param return.mcmc logical. If set to \code{TRUE}, the posterior means and the partitions
#'                   in each iteration are returned.
#' @param boundaryType (optional) only applicable for graph change point analysis. Values can be ``node'' (default) if we count nodes in the boundary length calculation, or ``edge'' if we count edges in the boundary length calculation. See Wang and Emerson (2015) for details.
#' @param p1 (optional) only applicable for graph change point analysis. The proportion of Active Pixel Passes run that are the actual Active Pixel Passes specified in Barry and Hartigan (1994). \code{p1 = 0} corresponds to exclusively using the pseudo-Active Pixel Passes given in Wang and Emerson (2015). 
#' @param freqAPP (optional) only applicable for graph change point analysis. A positive integer for the number of Active Pixel Passes run in each step of the MCMC algorithm. 
#' @param nreg (optional) only applicable for regression; related to parameter 
#' \code{d} describing the minimum number of observations needed in a block to allow for fitting a regression model. Defaults to 2*number of predictors. 
#'
#' @return Returns a list containing the following components:
#' \describe{
#'   \item{data}{a copy of the data.}
#' \item{return.mcmc}{\code{TRUE} or \code{FALSE} as specified by the user; see the arguments, above.}
#' \item{mcmc.means}{if \code{return.mcmc=TRUE}, \code{mcmc.means} contains the means for each iteration conditional on the state of the partition.}
#' \item{mcmc.rhos}{if \code{return.mcmc=TRUE}, \code{mcmc.rhos} contains the partitions after each iteration. A value of 1 indicates the end of a block.}
#' \item{blocks}{a vector of the number of blocks after each iteration.}
#' \item{posterior.mean}{a vector or matrix of the estimated posterior means. In the regression case, the matrix includes posterior means for the response variable.}
#' \item{posterior.var}{a vector or matrix of the estimated posterior variances. In the regression case, the estimated posterior variances of the response are provided.}
#' \item{posterior.prob}{a vector of the estimated posterior probabilities of changes at each location.}
#' \item{burnin}{the number of burnin iterations.}
#' \item{mcmc}{the number of iterations after burnin.}
#' \item{w0}{see the arguments, above.}
#' \item{p0}{see the arguments, above.}
#' }
#' @references 
#' \enumerate{
#' \item J. Bai and P. Perron (2003), Computation and Analysis of Multiple Structural Change Models, \emph{Journal of Applied Econometrics}, \bold{18}, 1-22. \url{http://qed.econ.queensu.ca/jae/2003-v18.1/bai-perron/}.
#' 
#' \item Daniel Barry and J. A. Hartigan (1993), A Bayesian Analysis for Change Point Problems, \emph{Journal of The American Statistical Association}, \bold{88}, 309-19.
#' 
#' \item Daniel Barry and J. A. Hartigan (1994), A Product Partition Model for Image Restoration, \emph{New Directions in Statistical Data Analysis and Robustness}, (Monte Verita : Proceedings of the Cento Stefano Franscini Ascona), Birkhauser, 9-23.
#' 
#' \item Chandra Erdman and John W. Emerson (2008), A Fast Bayesian Change Point Analysis for the Segmentation of Microarray Data, \emph{Bioinformatics}, 24(19), 2143-2148. \url{https://pubmed.ncbi.nlm.nih.gov/18667443/}.
#' 
#' \item Chandra Erdman and John W. Emerson (2007), bcp: An R Package for Performing a Bayesian Analysis of Change Point Problems. \emph{Journal of Statistical Software}, 23(3), 1-13. \url{https://www.jstatsoft.org/v23/i03/}.
#' 
#' \item A. B. Olshen, E. S. Venkatraman, R. Lucito, M. Wigler (2004), Circular binary segmentation for the analysis of array-based DNA copy number data, \emph{Biostatistics}, \bold{5}, 557-572.  \url{https://www.bioconductor.org/packages/release/bioc/html/DNAcopy.html}.
#' 
#' \item Snijders \emph{et al.} (2001), Assembly of microarrays for genome-wide measurement of DNA copy number, \emph{Nature Genetics}, \bold{29}, 263-264. 
#' 
#' \item Xiaofei Wang and John W. Emerson (2015). Bayesian Change Point Analysis of Linear Models on General Graphs, \emph{Working Paper}.
#' 
#' \item Achim Zeileis, Friedrich Leisch, Kurt Hornik, Christian Kleiber (2002), strucchange: An R Package for Testing for Structural Change in Linear Regression Models, \emph{Journal of Statistical Software}, \bold{7}(2), 1-38. \url{https://www.jstatsoft.org/v07/i02/}. 
#' }
#' @author Xiaofei Wang, Chandra Erdman, and John W. Emerson
#' @seealso \code{\link{plot.bcp}}, \code{\link{summary.bcp}}, and \code{\link{print.bcp}} for summaries of the results.
#' @import graphics
#' @examples
#' 
#' ##### univariate sequential data #####
#' # an easy problem with 2 true change points
#' set.seed(5)
#' x <- c(rnorm(50), rnorm(50, 5, 1), rnorm(50))
#' bcp.1a <- bcp(x)
#' plot(bcp.1a, main="Univariate Change Point Example")
#' legacyplot(bcp.1a)
#' 
#' # a hard problem with 1 true change point
#' set.seed(5)
#' x <- rep(c(0,1), each=50)
#' y <- x + rnorm(50, sd=1)
#' bcp.1b <- bcp(y)
#' plot(bcp.1b, main="Univariate Change Point Example")
#' 
#' ##### multivariate sequential data #####
#' # an easy problem in k=3 dimensions
#' set.seed(5)
#' x <- rnorm(6, sd=3)
#' y <- rbind(cbind(rnorm(50, x[1]), rnorm(50, x[2]), rnorm(50, x[3])),
#'            cbind(rnorm(50, x[4]), rnorm(50, x[5]), rnorm(50, x[6])))
#' bcp.2a <- bcp(y)
#' plot(bcp.2a, main="Multivariate (k=3) Change Point Example")
#' plot(bcp.2a, separated=TRUE, main="Multivariate (k=3) Change Point Example")
#' 
#' # a harder problem in k=5 dimensions
#' set.seed(5)
#' means1 <- rep(0, 5)
#' means2 <- rep(1, 5)
#' x <- rbind(matrix(rep(means1, each=50), nrow=50),
#'            matrix(rep(means2, each=50), nrow=50))
#' y <- x + rnorm(length(x), sd=1)
#' bcp.2b <- bcp(cbind(y))
#' plot(bcp.2b, main="Multivariate (k=5) Change Point Example")
#' 
#' ##### linear models with sequential data #####
#' # 1 true change point at location 50; the predicting variable x is not related to location
#' x <- rnorm(100)
#' b <- rep(c(3,-3), each=50)
#' y <- b*x + rnorm(100)
#' bcp.3a <- bcp(y, x)
#' # in the two plots that follow, the location IDs are used as the plot characters
#' par(mfrow=c(1,2))
#' plot(y ~ x, type="n", main="Linear Regression: Raw Data")
#' text(x, y, as.character(1:100), col=(b/3)+2)
#' plot(y ~ x, type="n", main="Linear Regression: Posterior Means")
#' text(x, bcp.3a$posterior.mean[,1], as.character(1:100), col=(b/3)+2)
#' plot(bcp.3a, main="Linear Regression Change Point Example")
#' 
#' # 1 true change point at location 50; the predicting variable x is equal to location
#' x <- 1:100
#' b <- rep(c(3,-3), each=50)
#' y <- b*x + rnorm(100, sd=50)
#' bcp.3b <- bcp(y, x)
#' plot(bcp.3b, main="Linear Regression Change Point Example")
#' 
#' ##### univariate data on a grid #####  
#' \dontrun{
#' set.seed(5)
#' adj <- makeAdjGrid(20)
#' z <- rep(c(0, 2), each=200)
#' y <- z + rnorm(400, sd=1)
#' out <- bcp(y, adj=adj, burnin=500, mcmc=500)
#' 
#' if (require("ggplot2")) {
#'   df <- data.frame(mean=z, data = y, post.means = out$posterior.mean[,1], 
#'                    post.probs = out$posterior.prob, 
#'                    i = rep(1:20, each=20), j = rep(1:20, times=20))
#' 
#'   # visualize the means
#'   g <- ggplot(df, aes(i,j)) + 
#'          geom_tile(aes(fill = mean), color='white') +
#'          scale_fill_gradientn(limits=range(y), colours=c('white', 'steelblue'))+
#'          ggtitle("True Means")
#'   print(g)
#' 
#'   # visualize the data
#'   g <- ggplot(df, aes(i,j)) + 
#'          geom_tile(aes(fill = data), color='white') +
#'          scale_fill_gradientn(limits=range(y), colours=c('white', 'steelblue'))+
#'          ggtitle("Observed Data")
#'   print(g)
#' 
#'   # visualize the posterior means/probs
#'   g <- ggplot(df, aes(i,j)) + 
#'          geom_tile(aes(fill = post.means), color='white') +
#'          scale_fill_gradientn(limits=range(y), colours=c('white', 'steelblue'))+
#'          ggtitle("Posterior Means")
#'   print(g)
#' 
#'   g <- ggplot(df, aes(i,j)) + 
#'          geom_tile(aes(fill = post.probs), color='white') +
#'          scale_fill_gradientn(limits=c(0, 1), colours=c('white', 'steelblue'))+
#'          ggtitle("Posterior Boundary Probabilities")
#'   print(g)
#' }
#' }
#' 
#' \dontrun{
#' ##### multivariate data on a grid #####
#' set.seed(5)
#' x <- rnorm(6, sd=3)
#' y <- rbind(cbind(rnorm(50, x[1]), rnorm(50, x[2]), rnorm(50, x[3])),
#'            cbind(rnorm(50, x[4]), rnorm(50, x[5]), rnorm(50, x[6])))
#' adj <- makeAdjGrid(10)
#' a <- bcp(y, adj=adj, p0=0.4, burnin=500, mcmc=500)
#' 
#' ##### linear models on a grid #####
#' set.seed(5)
#' x <- rnorm(100)
#' b <- rep(c(3,-3), each=50)
#' y <- b*x + rnorm(100)
#' adj <- makeAdjGrid(10)
#' a <- bcp(y,x,adj=adj, p0=0.4, burnin=500, mcmc=500)
#' 
#' ##### linear models on a grid using pseudo-APPs #####
#' x <- rnorm(100)
#' b <- rep(c(3,-3), each=50)
#' y <- b*x + rnorm(100)
#' adj <- makeAdjGrid(10)
#' a <- bcp(y,x,adj=adj, p0=0.4, burnin=500, mcmc=500, p1 = 0)}
#' 
#' ##### univariate data on a graph ##### 
#' \dontrun{ 
#'   demo(bcpgraph)
#' }
#' 
#' ###### Real Data Examples ######
#' \dontrun{
#' # Coriell chromosome 11: univariate sequential data
#' demo(coriell)
#' 
#' # U.S. ex-post interest rate: univariate sequential data
#' demo(RealInt)
#' 
#' # Lombard: univariate sequential data (with and without linear models)
#' demo(Lombard)
#' 
#' # Quebec rivers: multivariate sequential data
#' demo(QuebecRivers)
#' 
#' # New Haven housing: linear models on a graph
#' demo(NewHaven)
#' } 
#' 
#' @keywords datasets
#' @export
"bcp" <- function(y, x=NULL, id = NULL, adj=NULL, w0=NULL, p0=0.2, d = 10, 
                  burnin=50, mcmc=500, return.mcmc=FALSE, 
                  boundaryType = "node", p1 = 1, freqAPP = 20, 
                  nreg = -1) {
  
  ######################################################
  ########################### BEGIN THE WORKER FUNCTION:
  ######################################################
  
  "worker.bcp" <- function(mcmc, y, x, id, w0, p0, d, burnin, return.mcmc, membinit,
                           boundaryType, adj, p1, freqAPP, nreg) {
    
    require(bcp)
    
    # INITIALIZATION
    #  if (is.data.frame(x)) x <- matrix(as.double(x), nrow=nrow(x), ncol=ncol(x))
    #  if (is.vector(x)) x <- matrix(as.double(x), ncol=1)
    #  if (!is.matrix(x)) stop("x must be a vector, matrix or a data frame")
    #  if (nrow(x)==1) {
    #    warning("coercing data to a single series")
    #    x <- matrix(as.vector(x), ncol=1)
    #  }
    if (p0 > 1 | p0 < 0 | p1 > 1 | p1 < 0) stop ("p0 and p1 must each be between 0 and 1.")
    if (is.null(id)) {
      if (is.matrix(y)) id <- 1:nrow(y)
      else id <- 1:length(y)
    }
    if (min(id) == 1) id <- id - 1
    if (is.null(x)) {
      # doing multivariate bcp
      if (is.null(w0)) w0 <- 0.2
      if (w0 > 1 | w0 < 0) stop("w0 must be between 0 and 1.")
      if (is.vector(y)) y <- cbind(y)
      
      colnames(y) <- NULL
      rownames(y) <- NULL
      # Do the work in C:
      if (is.null(adj)) {
        out <- rcpp_bcpM(
          as.matrix(y), as.integer(id),
          as.integer(return.mcmc),
          as.integer(burnin), 
          as.integer(mcmc),     
          as.double(p0),
          as.double(w0))      
        attr(out, "structure") <- "series"
      } else {
        if (freqAPP < 0) stop("freqAPP must be a positive integer.")
        out <- rcpp_ppm(y, as.integer(id),
                        adj,
                        as.integer(return.mcmc),
                        as.integer(burnin), 
                        as.integer(mcmc),     
                        as.double(p0),
                        as.double(w0),
                        membinit,
                        as.integer(boundaryType),
                        as.double(p1),
                        as.integer(freqAPP))
        attr(out, "structure") <- "graph"
      }
      attr(out, "model") <- "multivariate"
      out$data <- cbind(id+1, y) 
      if (is.null(colnames(x))) {
        colnames(out$posterior.mean) <- paste(rep("X", ncol(out$data)-1), 
                                              1:(ncol(out$data)-1), sep="")
      } else
        colnames(out$posterior.mean) <- colnames(x)
    } else {
      # doing regression bcp
      if (is.vector(x)) x <- cbind(x)
      if (sum(x[,1]==1) != nrow(x)) x <- cbind(1, x) 
      if (!is.double(x)) x <- matrix(as.double(x), nrow(x), ncol(x))
      if (is.null(w0)) {
        w0 <- rep(0.2, ncol(x))
      } else {
        if (any(w0 > 1) | any(w0 < 0)) stop("Each element in w0 must be between 0 and 1.")
        if (length(w0) != ncol(x)) {
          if (length(w0) == 1) {
            w0 <- rep(w0, ncol(x))
            message("Incorrect length for w0. I'll assume you wanted each error-to-signal ratio to be iid from U(0, w0).")
          } else stop("Incorrect length for w0.")
        }
      }  
      if (nreg == -1) {
        nreg <- 2*(ncol(x)-1)
      }  
        indmat <- t(sapply(unique(id), function(y) id == y)*1)   
        # Do the work in C:
        if (is.null(adj)) {
          out <- rcpp_bcpR( 
            as.double(y),
            x,
            indmat,
            as.integer(id),
            as.integer(return.mcmc),
            as.integer(burnin), 
            as.integer(mcmc),     
            as.double(p0),
            as.double(w0),
            as.double(d),
            as.integer(nreg)
          )
          out$data = cbind(id+1, y,x[,-1])
          attr(out, "structure") <- "series"
        } else {
          if (freqAPP < 0) stop("freqAPP must be a positive integer.")
          out <- rcpp_ppmR(y, x,                    
                           indmat,
                           as.integer(id), 
                           adj,
                           as.integer(return.mcmc),
                           as.integer(burnin), 
                           as.integer(mcmc),     
                           as.double(p0),
                           as.double(w0),
                           membinit,
                           as.integer(boundaryType),
                           as.double(d),
                           as.double(p1),
                           as.integer(freqAPP),
                           as.integer(nreg))
          out$data = cbind(id+1, y,x)
          attr(out, "structure") <- "graph"
        }
        attr(out, "model") <- "regression"
        out$posterior.mean <- cbind(as.numeric(out$posterior.mean)/table(id))
        rownames(out$posterior.mean) <- NULL
        colnames(out$posterior.mean) <- "y"
      }
      if (attr(out, "structure") == "series") 
        out$posterior.prob[length(out$posterior.prob)] <- NA     # Fix up the last position, always NA
      
      # RETURN RESULTS
      z <- list(data=out$data,
                return.mcmc=return.mcmc,
                mcmc.means=out$mcmc.means,
                mcmc.rhos=out$mcmc.rhos,
                blocks=out$blocks,
                posterior.mean=out$posterior.mean,
                posterior.var=out$posterior.var,
                posterior.prob=out$posterior.prob,
                burnin=burnin,            
                mcmc=mcmc,     
                p0=p0,     
                w0=w0)     
      attr(z, "model") <- attr(out, "model")
      attr(z, "structure") <- attr(out, "structure")
      class(z) <- "bcp"
      return(z)
    }
    
    ###################################################
    ########################### END THE WORKER FUNCTION
    ########################### BEGIN THE MAIN SECTION:
    ###################################################
    
    # Function header and foreach setup, from above:
    #
    #"bcp" <- function(x, w0=0.2, p0=0.2, burnin=50, mcmc=500, return.mcmc=FALSE) {
    #
    
    if (!is.null(adj)) {
      if (boundaryType == "node") {
        boundaryType <- 1
      } else {
        boundaryType <- 2
      }
      
      if (is.vector(y)) {
        dataToRank <- y
      } else if (is.matrix(y)) {
        dataToRank <- y[,1]
      }
      if (!is.null(id)) { # varying num of obs per loc, we'll sample one obs per loc to rank
        inds <- sapply(1:max(id), function(g) {
          inds <- which(id==g)
          if (length(inds)==1) return(inds)
          return(sample(inds, 1))
        })
        dataToRank <- dataToRank[inds]
      }
      numNodes <- length(dataToRank)
      # if (is.null(membinit)) {
      Minit <- ceiling(sqrt(numNodes))
      o <- rank(dataToRank, ties.method="first")    
      membinit <- ceiling(o/Minit)
      membinit <- pmin(membinit, Minit)-1
      # } else if (length(membinit) == 1) {
      #   Minit <- ceiling(numNodes/membinit)
      #   o <- rank(dataToRank, ties.method="first")    
      #   membinit <- ceiling(o/Minit)
      #   membinit <- pmin(membinit, Minit)-1
      # } else {
      #   nComponents <- max(membinit)
      #   if (length(setdiff(unique(membinit), 1:nComponents))>0) {
      #     stop("Error in membinit")
      #   } else {
      #     membinit <- membinit-1
      #   }
      # }
      relabelMap <- order(unique(membinit))
      membinit <- relabelMap[membinit+1]-1
    }
    
    ans <- worker.bcp(mcmc, y=y, x=x, id=id, w0=w0, p0=p0, d=d, 
                      burnin=burnin, return.mcmc=return.mcmc,
                      membinit=membinit, boundaryType=boundaryType,
                      adj=adj, p1=p1, freqAPP=freqAPP, nreg=nreg)
    #  ==================================
    #  ===  Reformat the mcmc.means   ===
    #  ==================================
    if (return.mcmc) {
      if (ncol(ans$mcmc.means) > 1) {
        mcmc.means <- vector('list', ncol(ans$mcmc.means)) 
        for (i in 1:length(mcmc.means)) {
          mcmc.means[[i]] <- matrix(ans$mcmc.means[,i], nrow=burnin+mcmc, byrow=TRUE)
        }
      } else {
        mcmc.means <- matrix(ans$mcmc.means, nrow=burnin+mcmc, byrow=TRUE)
      }
      ans$mcmc.means <- mcmc.means
    } 
    return(ans)
  }
  
  #' @title Creating the adjacency structure for grid graphs
  #' 
  #' @description
  #' \code{makeAdjGrid()} produces a sparse representation of the adjacency structure for grid graphs, useful as the \code{adj} argument in \code{bcp()}. 
  #'
  #' @param n the number of rows of vertices in the graph data.
  #' @param m (optional) the number of column of vertices in the graph data. If not given, we assume \code{m = n}.
  #' @param k (optional) the number of neighbors assumed for a typical vertex (see details below), either 4 or 8. Default number of neighbors is assumed to be 8.
  #' 
  #' @author Xiaofei Wang
  #' @details 
  #' \code{makeAdjGrid()} produces a list representation of the adjacency structure for grid graphs. The \eqn{i}-th entry in the list gives a vector of neighbor ids for the \eqn{i}-th node. Note that neighbor ids are offset by 1 because indexing starts at 0 in C++.
  #' If \code{k = 8}, then we assume each node is joined via edges to its 8 neighbors in the (top left, top middle, top right, left, right, bottom left, bottom middle, and bottom right) directions, where applicable. If \code{k = 4}, then we assume each node is joined via edges to its 4 neighbors in the (top, right, bottom, left) directions, where applicable.
  #' @seealso \code{\link{bcp}} for performing Bayesian change point analysis.
  #' @examples 
  #' # generates an adjacency list for a 10 node by 5 node grid, assuming a maximum of 8 neighbors
  #' adj <- makeAdjGrid(10, 5) 
  #' 
  #' # generates an adjacency list for a 10 node by 5 node grid, assuming a maximum of 4 neighbors
  #' adj4 <- makeAdjGrid(10, 5, 4)
  #' 
  #' 
  #' ### show a grid example
  #' \dontrun{
  #' set.seed(5)
  #' adj <- makeAdjGrid(20)
  #' z <- rep(c(0, 2), each=200)
  #' y <- z + rnorm(400, sd=1)
  #' out <- bcp(y, adj=adj, burnin=500, mcmc=500)
  #' 
  #' if (require("ggplot2")) {
  #'   df <- data.frame(mean=z, data = y, post.means = out$posterior.mean[,1], 
  #'                    post.probs = out$posterior.prob, 
  #'                    i = rep(1:20, each=20), j = rep(1:20, times=20))
  #' 
  #'   # visualize the data
  #'   g <- ggplot(df, aes(i,j)) + 
  #'          geom_tile(aes(fill = data), color='white') +
  #'          scale_fill_gradientn(limits=range(y), colours=c('white', 'steelblue'))+
  #'          ggtitle("Observed Data")
  #'   print(g)
  #' 
  #'   # visualize the means
  #'   g <- ggplot(df, aes(i,j)) + 
  #'          geom_tile(aes(fill = mean), color='white') +
  #'          scale_fill_gradientn(limits=range(y), colours=c('white', 'steelblue'))+
  #'          ggtitle("True Means")
  #'   print(g)
  #' 
  #'   # visualize the posterior means/probs
  #'   g <- ggplot(df, aes(i,j)) + 
  #'          geom_tile(aes(fill = post.means), color='white') +
  #'          scale_fill_gradientn(limits=range(y), colours=c('white', 'steelblue'))+
  #'          ggtitle("Posterior Means")
  #'   print(g)
  #' 
  #'   g <- ggplot(df, aes(i,j)) + 
  #'          geom_tile(aes(fill = post.probs), color='white') +
  #'          scale_fill_gradientn(limits=c(0, 1), colours=c('white', 'steelblue'))+
  #'          ggtitle("Posterior Boundary Probabilities")
  #'   print(g)
  #' }
  #' }
  #' 
  #' @keywords datasets
  #' @export
  makeAdjGrid <- function(n,m=NULL, k=8) {
    if (is.null(m)) m <- n
    adj <- vector('list', n*m)
    
    if (k == 8) {
      for (i in 2:(n-1)) {
        for (j in 2:(m-1)) {
          adj[[(j-1)*n+i]] <- c((j-2)*n+(i-1):(i+1),(j-1)*n+i-c(1,-1), j*n+(i-1):(i+1))-1
        }
      }
      i <- 1
      for (j in 2:(m-1)) adj[[(j-1)*n+i]] <- c((j-2)*n+1:2, (j-1)*n+2, (j)*n+1:2)-1
      i <- n
      for (j in 2:(m-1))  adj[[(j-1)*n+i]] <- c((j-1)*n-1:0, j*n-1, (j+1)*n-1:0)-1
      j <- 1
      for (i in 2:(n-1)) adj[[(j-1)*n+i]] <- c(i-1,i+1, n+(i-1):(i+1))-1
      j <- m
      for (i in 2:(n-1)) adj[[(j-1)*n+i]] <- c((m-2)*n+(i-1):(i+1), (m-1)*n+i-1, (m-1)*n+i+1)-1
      adj[[1]] <- c(2, n+1:2)-1
      adj[[n]] <- c((1:2)*n-1,2*n)-1
      adj[[(m-1)*n+1]] <-  c((m-2)*n+1:2, (m-1)*n+2)-1
      adj[[n*m]] <- c((m-1)*n-(1:0), n*m-1)-1
    } else if (k == 4) {
      for (i in 2:(n-1)) {
        for (j in 2:(m-1)) {
          adj[[(j-1)*n+i]] <- c((j-2)*n+i,(j-1)*n+i-c(1,-1), j*n+i)-1
        }
      }
      i <- 1
      for (j in 2:(m-1)) adj[[(j-1)*n+i]] <- c((j-2)*n+1, (j-1)*n+2, (j)*n+1)-1
      i <- n
      for (j in 2:(m-1))  adj[[(j-1)*n+i]] <- c((j-1)*n, j*n-1, (j+1)*n)-1
      j <- 1
      for (i in 2:(n-1)) adj[[(j-1)*n+i]] <- c(i-1,i+1, n+i)-1
      j <- m
      for (i in 2:(n-1)) adj[[(j-1)*n+i]] <- c((n-2)*m+i, (n-1)*m+i-1, (n-1)*m+i+1)-1
      adj[[1]] <- c(2, n+1)-1
      adj[[n]] <- c(n-1,2*n)-1
      adj[[(m-1)*n+1]] <-  c((m-2)*n+1, (m-1)*n+2)-1
      adj[[n*m]] <- c((m-1)*n, n*m-1)-1
    } else {
      stop("Error: k must be 4 or 8.")
    }
    return(adj)
  }
  
  
  

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/output.R
\name{legacyplot}
\alias{legacyplot}
\title{Plotting univariate Bayesian change point results}
\usage{
legacyplot(x, ...)
}
\arguments{
\item{x}{the result of a call to \code{bcp()}.}

\item{...}{(optional) additional arguments, ignored.}
}
\description{
\code{legacyplot()} produces summary plots of the results of \code{bcp()} when used for univariate analysis; it was the default method prior to package version 3.0.0.
}
\details{
\code{legacyplot()} produces the following plots using \code{base} graphics:

Posterior Means: location in the sequence versus the posterior mean over the iterations. 

Posterior Probability of a Change: location in the sequence versus the relative frequency of iterations which resulted in a change point.
}
\value{No return value, called for plotting the result}
\examples{
##### A random sample from a few normal distributions #####
testdata <- c(rnorm(50), rnorm(50, 5, 1), rnorm(50))
bcp.0 <- bcp(testdata, return.mcmc=TRUE)
legacyplot(bcp.0)

}
\seealso{
\code{\link{plot.bcp}}, \code{\link{bcp}}, \code{\link{summary.bcp}}, and \code{\link{print.bcp}} for complete results and summary statistics.
}
\author{
Chandra Erdman and John W. Emerson
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bcp-data.R
\docType{data}
\name{QuebecRivers}
\alias{QuebecRivers}
\title{Quebec river streamflow data}
\format{A matrix containing streamflow amounts for the years 1972 to 1994.}
\source{
The data can be obtained from the Centre d'expertise hydrique Quebec. \url{https://www.cehq.gouv.qc.ca/hydrometrie/index-en.htm}
}
\usage{
QuebecRivers
}
\description{
Annual January to June streamflow amounts (measured in \eqn{L/(km^2 s)}) for four rivers in Quebec: Baleine, Churchill Falls, Manicouagan, and Romaine.
}
\examples{
 
data("QuebecRivers")
bcpr.rivers <- bcp(QuebecRivers)
plot(bcpr.rivers, main="Quebec River Streamflow Change Point Analysis", 
     xlab="Year", xaxlab = 1972:1994)

}
\references{
\enumerate{ 
\item Xiaofei Wang and John W. Emerson (2015). Bayesian Change Point Analysis of Linear Models on General Graphs, \emph{Working Paper}.
\item L. Perrault \emph{et al.} (2000). Retrospective multivariate Bayesian change-point analysis: a simultaneous single change in the mean of several hydrological sequences, \emph{Stochastic Environmental Research and Risk Assessment}, \bold{14}, 243-261.
}
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bcp-data.R
\docType{data}
\name{coriell}
\alias{coriell}
\title{Array CGH data set of Coriell cell lines}
\format{A data frame containing five variables: first is clone name, second is clone chromosome, third is   clone position, fourth and fifth  are log2ratio for two cell lines.}
\source{
\url{ https://www.nature.com/articles/ng754}
}
\usage{
coriell
}
\description{
These are two data array CGH studies of Coriell cell lines taken from the reference below.
}
\examples{
demo(coriell)

}
\references{
\enumerate{ 
\item Olshen, A. B., Venkatraman, E. S., Lucito, R., Wigler, M. (2004), Circular binary segmentation for the analysis of array-based DNA copy number data, \emph{Biostatistics}, \bold{5}, 557-572. url: \url{https://www.bioconductor.org/packages/release/bioc/html/DNAcopy.html}.
\item Snijders \emph{et al.} (2001), Assembly of microarrays for genome-wide measurement of DNA copy number, \emph{Nature Genetics}, \bold{29}, 263-264. 
}
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/output.R
\name{interval.prob}
\alias{interval.prob}
\title{Estimate the probability of a change point in a specified interval}
\usage{
interval.prob(object, start, end)
}
\arguments{
\item{object}{the result of a call to \code{bcp()}.}

\item{start}{the starting index of the interval.}

\item{end}{the ending index of the interval.}
}
\description{
The function \code{interval.prob()} estimates the probability of at least one
change point in the specified interval of sequential observations; it may only be used when \code{return.mcmc=TRUE}.
}
\value{
For sequential data only, the function returns an estimate of the posterior probability of at least one change point in the specified interval.
}
\note{
\code{return.mcmc} must be \code{TRUE}.
}
\examples{
##### A random sample from a few normal distributions #####
testdata <- c(rnorm(50), rnorm(50, 5, 1), rnorm(50))
bcp.0 <- bcp(testdata, return.mcmc=TRUE)
plot(bcp.0, main="Univariate Change Point Example")
interval.prob(bcp.0, 45, 55)

}
\seealso{
\code{\link{bcp}} and \code{\link{plot.bcp}}.
}
\author{
Xiaofei Wang, Chandra Erdman, and John W. Emerson
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/output.R
\name{residuals.bcp}
\alias{residuals.bcp}
\title{Extract model residuals}
\usage{
\method{residuals}{bcp}(object, ...)
}
\arguments{
\item{object}{the result of a call to \code{bcp()}.}

\item{...}{(optional) additional arguments, ignored.}
}
\value{
Residuals extracted from the \code{bcp} object.
}
\description{
residuals method for class \code{bcp}.
}
\examples{
##### A random sample from a few normal distributions #####
testdata <- c(rnorm(50), rnorm(50, 5, 1), rnorm(50))
bcp.0 <- bcp(testdata)
residuals(bcp.0)

}
\seealso{
\code{\link{bcp}} and \code{\link{plot.bcp}}
}
\author{
Xiaofei Wang, Chandra Erdman, and John W. Emerson
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/output.R
\name{summary.bcp}
\alias{summary.bcp}
\alias{print.bcp}
\title{Summarizing Bayesian change point analysis results}
\usage{
\method{summary}{bcp}(object, digits = max(3, .Options$digits - 3), ...)

\method{print}{bcp}(x, digits = max(3, .Options$digits - 3), ...)
}
\arguments{
\item{object}{the result of a call to \code{bcp()}.}

\item{digits}{the number of digits displayed in the summary statistics.}

\item{...}{(optional) additional arguments, ignored.}

\item{x}{the result of a call to \code{bcp()}.}
}
\value{
The matrix of results is returned invisibly.
}
\description{
Summary and print methods for class \code{bcp}.
}
\details{
The functions print (and return invisibly) the estimated posterior probability of a change point for each position and the estimated posterior means. These results are modeled after the summary method of the \code{coda} package (Plummer \emph{et al.}, 2006). If \code{return.mcmc=TRUE} (i.e., if full MCMC results are returned), \code{bcp} objects can be converted into \code{mcmc} objects to view \code{mcmc} summaries -- see examples below.
}
\examples{
##### A random sample from a few normal distributions #####
testdata <- c(rnorm(50), rnorm(50, 5, 1), rnorm(50))
bcp.0 <- bcp(testdata)
summary(bcp.0)
plot(bcp.0, main="Univariate Change Point Example")

##### An MCMC summary from the ``coda'' package #####
\donttest{
 
if(requireNamespace("coda")) {
  bcp.0 <- bcp(testdata, return.mcmc=TRUE)
  bcp.mcmc <- as.mcmc(t(bcp.0$mcmc.means))
  summary(bcp.mcmc)
  heidel.diag(bcp.mcmc) # an example convergence diagnostic
  # from the coda package.
}
}
}
\seealso{
\code{\link{bcp}} and \code{\link{plot.bcp}}.
}
\author{
Xiaofei Wang, Chandra Erdman, and John W. Emerson
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bcp.R
\name{bcp}
\alias{bcp}
\title{Performs a Bayesian analysis of change point problems}
\usage{
bcp(y, x = NULL, id = NULL, adj = NULL, w0 = NULL, p0 = 0.2,
  d = 10, burnin = 50, mcmc = 500, return.mcmc = FALSE,
  boundaryType = "node", p1 = 1, freqAPP = 20, nreg = -1)
}
\arguments{
\item{y}{a vector or matrix of numerical data (with no missing values). For
the multivariate change point problems, each column corresponds to a series.}

\item{x}{(optional) a matrix of numerical data (with no missing values) representing the predicting variables for a linear regression.}

\item{id}{(optional) a vector of integers specifying the location ID for each observation in \code{y}, starting from location 1.}

\item{adj}{(optional) an adjacency list. Indexing the observations from 1 to \eqn{n}, the \eqn{i}-th element of the list is a vector of indices (offset by 1) for nodes that share an edge with node \eqn{i}.}

\item{w0}{(optional) a single numeric value in the multivariate case or a vector of values in the regression case; in both, the value(s), between 0 and 1, is/are the parameter(s) in the uniform prior(s) on the signal-to-noise
ratio(s).  If no value is specified, the default value of 0.2 is used, as    
recommended by Barry and Hartigan (1993).}

\item{p0}{(optional) a value between 0 and 1. For sequential data, it is the parameter of the prior on change point probabilities, \eqn{U(0,}\code{ p0}\eqn{)}, on the probability
of a change point at each location in the sequence; for data on a graph, it is the parameter in the partition prior, \code{p0}\eqn{^{l(\rho)}}, where \eqn{l(\rho)} is the boundary length of the partition.}

\item{d}{(optional) a positive number only used for linear regression change point models. Lower \code{d} means higher chance of fitting the full linear model (instead of the intercept-only model); see prior for \eqn{\tau_S} in Wang and Emerson (2015).}

\item{burnin}{the number of burnin iterations.}

\item{mcmc}{the number of iterations after burnin.}

\item{return.mcmc}{logical. If set to \code{TRUE}, the posterior means and the partitions
in each iteration are returned.}

\item{boundaryType}{(optional) only applicable for graph change point analysis. Values can be ``node'' (default) if we count nodes in the boundary length calculation, or ``edge'' if we count edges in the boundary length calculation. See Wang and Emerson (2015) for details.}

\item{p1}{(optional) only applicable for graph change point analysis. The proportion of Active Pixel Passes run that are the actual Active Pixel Passes specified in Barry and Hartigan (1994). \code{p1 = 0} corresponds to exclusively using the pseudo-Active Pixel Passes given in Wang and Emerson (2015).}

\item{freqAPP}{(optional) only applicable for graph change point analysis. A positive integer for the number of Active Pixel Passes run in each step of the MCMC algorithm.}

\item{nreg}{(optional) only applicable for regression; related to parameter 
\code{d} describing the minimum number of observations needed in a block to allow for fitting a regression model. Defaults to 2*number of predictors.}
}
\value{
Returns a list containing the following components:
\describe{
  \item{data}{a copy of the data.}
\item{return.mcmc}{\code{TRUE} or \code{FALSE} as specified by the user; see the arguments, above.}
\item{mcmc.means}{if \code{return.mcmc=TRUE}, \code{mcmc.means} contains the means for each iteration conditional on the state of the partition.}
\item{mcmc.rhos}{if \code{return.mcmc=TRUE}, \code{mcmc.rhos} contains the partitions after each iteration. A value of 1 indicates the end of a block.}
\item{blocks}{a vector of the number of blocks after each iteration.}
\item{posterior.mean}{a vector or matrix of the estimated posterior means. In the regression case, the matrix includes posterior means for the response variable.}
\item{posterior.var}{a vector or matrix of the estimated posterior variances. In the regression case, the estimated posterior variances of the response are provided.}
\item{posterior.prob}{a vector of the estimated posterior probabilities of changes at each location.}
\item{burnin}{the number of burnin iterations.}
\item{mcmc}{the number of iterations after burnin.}
\item{w0}{see the arguments, above.}
\item{p0}{see the arguments, above.}
}
}
\description{
\code{bcp()} implements the Bayesian change point analysis methods given in Wang and Emerson (2015), of which the Barry and Hartigan (1993) product
partition model for the normal errors change point problem is a specific case. 1. Multivariate (or univariate) Bayesian change point analysis: We assume there exists an unknown partition of a data series y
into blocks such that the mean is constant within each block.  In the multivariate
case, a common change point structure
is assumed; means are constant within each block of each sequence, but may differ across sequences
within a given block. Conditional on the partition, the model assumes that observations are independent, identically distributed normal, with constant means within blocks and
constant variance throughout each sequence.  
2. Linear regression Bayesian change point analysis: As with the previous model, we assume the observations (x,y), where x may be multivariate, are partitioned into blocks, and that linear models are appropriate within each block. 

If an adjacency structure is provided, the data are assumed to reside on nodes of a graph with the given adjacency structure; additional parameters are used in this graph change point model. If no adjacency structure is provided, the data are assumed to be sequential and the blocks are forced to be contiguous.
}
\details{
The primary result is an estimate of the posterior mean (or its distribution if
\code{return.mcmc} is \code{TRUE}) at every location.  Unlike a frequentist or
algorithmic approach to the problem, these estimates will not be constant within
regions, and no single partition is identified as best.  Estimates of the
probability of a change point at any given location are provided, however.

The user may set \code{.Random.seed} to control the MCMC iterations.

The functions \code{\link{summary.bcp}}, \code{\link{print.bcp}}, and \code{\link{plot.bcp}} are
used to obtain summaries of the results; \code{\link{legacyplot}} is included
from package versions prior to 3.0.0 and will only work for univariate change
point analyses.
}
\examples{

##### univariate sequential data #####
# an easy problem with 2 true change points
set.seed(5)
x <- c(rnorm(50), rnorm(50, 5, 1), rnorm(50))
bcp.1a <- bcp(x)
plot(bcp.1a, main="Univariate Change Point Example")
legacyplot(bcp.1a)

# a hard problem with 1 true change point
set.seed(5)
x <- rep(c(0,1), each=50)
y <- x + rnorm(50, sd=1)
bcp.1b <- bcp(y)
plot(bcp.1b, main="Univariate Change Point Example")

##### multivariate sequential data #####
# an easy problem in k=3 dimensions
set.seed(5)
x <- rnorm(6, sd=3)
y <- rbind(cbind(rnorm(50, x[1]), rnorm(50, x[2]), rnorm(50, x[3])),
           cbind(rnorm(50, x[4]), rnorm(50, x[5]), rnorm(50, x[6])))
bcp.2a <- bcp(y)
plot(bcp.2a, main="Multivariate (k=3) Change Point Example")
plot(bcp.2a, separated=TRUE, main="Multivariate (k=3) Change Point Example")

# a harder problem in k=5 dimensions
set.seed(5)
means1 <- rep(0, 5)
means2 <- rep(1, 5)
x <- rbind(matrix(rep(means1, each=50), nrow=50),
           matrix(rep(means2, each=50), nrow=50))
y <- x + rnorm(length(x), sd=1)
bcp.2b <- bcp(cbind(y))
plot(bcp.2b, main="Multivariate (k=5) Change Point Example")

##### linear models with sequential data #####
# 1 true change point at location 50; the predicting variable x is not related to location
x <- rnorm(100)
b <- rep(c(3,-3), each=50)
y <- b*x + rnorm(100)
bcp.3a <- bcp(y, x)
# in the two plots that follow, the location IDs are used as the plot characters
oldpar = par(mfrow=c(1,2))
plot(y ~ x, type="n", main="Linear Regression: Raw Data")
text(x, y, as.character(1:100), col=(b/3)+2)
plot(y ~ x, type="n", main="Linear Regression: Posterior Means")
text(x, bcp.3a$posterior.mean[,1], as.character(1:100), col=(b/3)+2)
plot(bcp.3a, main="Linear Regression Change Point Example")

# 1 true change point at location 50; the predicting variable x is equal to location
x <- 1:100
b <- rep(c(3,-3), each=50)
y <- b*x + rnorm(100, sd=50)
bcp.3b <- bcp(y, x)
plot(bcp.3b, main="Linear Regression Change Point Example")

par(oldpar)

##### univariate data on a grid #####  
\donttest{
set.seed(5)
adj <- makeAdjGrid(20)
z <- rep(c(0, 2), each=200)
y <- z + rnorm(400, sd=1)
out <- bcp(y, adj=adj, burnin=500, mcmc=500)

if (require("ggplot2")) {
  df <- data.frame(mean=z, data = y, post.means = out$posterior.mean[,1], 
                   post.probs = out$posterior.prob, 
                   i = rep(1:20, each=20), j = rep(1:20, times=20))

  # visualize the means
  g <- ggplot(df, aes(i,j)) + 
         geom_tile(aes(fill = mean), color='white') +
         scale_fill_gradientn(limits=range(y), colours=c('white', 'steelblue'))+
         ggtitle("True Means")
  print(g)

  # visualize the data
  g <- ggplot(df, aes(i,j)) + 
         geom_tile(aes(fill = data), color='white') +
         scale_fill_gradientn(limits=range(y), colours=c('white', 'steelblue'))+
         ggtitle("Observed Data")
  print(g)

  # visualize the posterior means/probs
  g <- ggplot(df, aes(i,j)) + 
         geom_tile(aes(fill = post.means), color='white') +
         scale_fill_gradientn(limits=range(y), colours=c('white', 'steelblue'))+
         ggtitle("Posterior Means")
  print(g)

  g <- ggplot(df, aes(i,j)) + 
         geom_tile(aes(fill = post.probs), color='white') +
         scale_fill_gradientn(limits=c(0, 1), colours=c('white', 'steelblue'))+
         ggtitle("Posterior Boundary Probabilities")
  print(g)
}
}

\donttest{
##### multivariate data on a grid #####
set.seed(5)
x <- rnorm(6, sd=3)
y <- rbind(cbind(rnorm(50, x[1]), rnorm(50, x[2]), rnorm(50, x[3])),
           cbind(rnorm(50, x[4]), rnorm(50, x[5]), rnorm(50, x[6])))
adj <- makeAdjGrid(10)
a <- bcp(y, adj=adj, p0=0.4, burnin=500, mcmc=500)

##### linear models on a grid #####
set.seed(5)
x <- rnorm(100)
b <- rep(c(3,-3), each=50)
y <- b*x + rnorm(100)
adj <- makeAdjGrid(10)
a <- bcp(y,x,adj=adj, p0=0.4, burnin=500, mcmc=500)

##### linear models on a grid using pseudo-APPs #####
x <- rnorm(100)
b <- rep(c(3,-3), each=50)
y <- b*x + rnorm(100)
adj <- makeAdjGrid(10)
a <- bcp(y,x,adj=adj, p0=0.4, burnin=500, mcmc=500, p1 = 0)}

##### univariate data on a graph ##### 
\donttest{ 
  demo(bcpgraph)
}

###### Real Data Examples ######
\donttest{
# Coriell chromosome 11: univariate sequential data
demo(coriell)

# U.S. ex-post interest rate: univariate sequential data
demo(RealInt)

# Lombard: univariate sequential data (with and without linear models)
demo(Lombard)

# Quebec rivers: multivariate sequential data
demo(QuebecRivers)

# New Haven housing: linear models on a graph
demo(NewHaven)
} 

}
\references{
\enumerate{
\item J. Bai and P. Perron (2003), Computation and Analysis of Multiple Structural Change Models, \emph{Journal of Applied Econometrics}, \bold{18}, 1-22. \url{http://qed.econ.queensu.ca/jae/2003-v18.1/bai-perron/}.

\item Daniel Barry and J. A. Hartigan (1993), A Bayesian Analysis for Change Point Problems, \emph{Journal of The American Statistical Association}, \bold{88}, 309-19.

\item Daniel Barry and J. A. Hartigan (1994), A Product Partition Model for Image Restoration, \emph{New Directions in Statistical Data Analysis and Robustness}, (Monte Verita : Proceedings of the Cento Stefano Franscini Ascona), Birkhauser, 9-23.

\item Chandra Erdman and John W. Emerson (2008), A Fast Bayesian Change Point Analysis for the Segmentation of Microarray Data, \emph{Bioinformatics}, 24(19), 2143-2148. \url{https://pubmed.ncbi.nlm.nih.gov/18667443/}.

\item Chandra Erdman and John W. Emerson (2007), bcp: An R Package for Performing a Bayesian Analysis of Change Point Problems. \emph{Journal of Statistical Software}, 23(3), 1-13. \url{https://www.jstatsoft.org/v23/i03/}.

\item A. B. Olshen, E. S. Venkatraman, R. Lucito, M. Wigler (2004), Circular binary segmentation for the analysis of array-based DNA copy number data, \emph{Biostatistics}, \bold{5}, 557-572.  \url{https://www.bioconductor.org/packages/release/bioc/html/DNAcopy.html}.

\item Snijders \emph{et al.} (2001), Assembly of microarrays for genome-wide measurement of DNA copy number, \emph{Nature Genetics}, \bold{29}, 263-264. 

\item Xiaofei Wang and John W. Emerson (2015). Bayesian Change Point Analysis of Linear Models on General Graphs, \emph{Working Paper}.

\item Achim Zeileis, Friedrich Leisch, Kurt Hornik, Christian Kleiber (2002), strucchange: An R Package for Testing for Structural Change in Linear Regression Models, \emph{Journal of Statistical Software}, \bold{7}(2), 1-38. \url{https://www.jstatsoft.org/v07/i02/}. 
}
}
\seealso{
\code{\link{plot.bcp}}, \code{\link{summary.bcp}}, and \code{\link{print.bcp}} for summaries of the results.
}
\author{
Xiaofei Wang, Chandra Erdman, and John W. Emerson
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bcp-data.R
\docType{data}
\name{lombard}
\alias{lombard}
\title{Milling machine indentation data}
\format{A vector of length 100 containing the individual radii.}
\source{
The data is available online in the data archive of the
\emph{Journal of Applied Econometrics}. url: 
 \url{http://qed.econ.queensu.ca/jae/2003-v18.1/bai-perron/}.
}
\usage{
lombard
}
\description{
Radii of 100 circular indentations cut by a milling machine.
}
\examples{
 
\donttest{
data(lombard)
# univariate change point analysis
bcp.model <- bcp(lombard, burnin=500, mcmc=5000, return.mcmc=TRUE)

# linear model change point analysis 
bcpr.model <- bcp(lombard, cbind(1:100), burnin=500, mcmc=5000, return.mcmc=TRUE)

plot(bcp.model, main="Lombard Milling Data")
plot(bcpr.model, main="Lombard Milling Data (with Regression Model)")
}
}
\references{
\enumerate{ 
\item Daniel Barry and J. A. Hartigan (1993), A Bayesian Analysis for Change Point Problems, \emph{Journal of The American Statistical Association}, \bold{88}, 309-19.
\item F. Lombard (1987), Rank Tests for Changepoint Problems, \emph{Biometrika}, \bold{74}, 615-624. 
}
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bcp-data.R
\docType{data}
\name{RealInt}
\alias{RealInt}
\title{US Ex-post Real Interest Rate data, 1961(1):1986(3)}
\format{A quarterly time series from 1961(1) to 1986(3).}
\source{
The data is available online in the data archive of the
\emph{Journal of Applied Econometrics}. url: 
 \url{http://qed.econ.queensu.ca/jae/2003-v18.1/bai-perron/}.
}
\usage{
RealInt
}
\description{
US ex-post real interest rate: the three-month treasury bill
deflated by the CPI inflation rate.
}
\examples{
 
 \donttest{
 demo(RealInt)
 }


}
\references{
\enumerate{ 
\item J. Bai and P. Perron (2003), Computation and Analysis of Multiple Structural Change Models, \emph{Journal of Applied Econometrics}, \bold{18}, 1-22. \url{http://qed.econ.queensu.ca/jae/2003-v18.1/bai-perron/}.
\item Achim Zeileis, Friedrich Leisch, Kurt Hornik, Christian Kleiber (2002), strucchange: An R Package for Testing for Structural Change in Linear Regression Models, \emph{Journal of Statistical Software}, \bold{7}(2), 1--38. \url{https://www.jstatsoft.org/v07/i02/}.
}
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bcp-package.R
\docType{package}
\name{bcp-package}
\alias{bcp-package}
\title{Bayesian Analysis of Change Point Problems}
\description{
Provides an implementation of the Barry and Hartigan (1993) product partition model for the normal errors change point problem using Markov Chain Monte Carlo.  It also (i) extends the methodology to regression models on a connected graph (Wang and Emerson, 2015) and (ii) allows estimation of change point models with multivariate responses. Parallel MCMC, previously available in bcp v.3.0.0, is currently not implemented.
}
\author{
Xiaofei Wang, Chandra Erdman, and John W. Emerson
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bcp-data.R
\docType{data}
\name{NewHavenHousing}
\alias{NewHavenHousing}
\title{New Haven housing data}
\format{A matrix containing location, 2011 assessed value, and physical characteristics in the columns.}
\source{
The data can be scraped from the New Haven, CT Online Assessment Database \url{https://gis.vgsi.com/newhavenct/}
}
\usage{
NewHavenHousing
}
\description{
Location, 2011 assessed value, and physical characteristics for 244 houses in a region of New Haven, CT.
}
\examples{
 
\donttest{
demo("NewHaven")
}

}
\references{
Xiaofei Wang and John W. Emerson (2015). Bayesian Change Point Analysis of Linear Models on General Graphs, \emph{Working Paper}.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bcp.R
\name{makeAdjGrid}
\alias{makeAdjGrid}
\title{Creating the adjacency structure for grid graphs}
\usage{
makeAdjGrid(n, m = NULL, k = 8)
}
\arguments{
\item{n}{the number of rows of vertices in the graph data.}

\item{m}{(optional) the number of column of vertices in the graph data. If not given, we assume \code{m = n}.}

\item{k}{(optional) the number of neighbors assumed for a typical vertex (see details below), either 4 or 8. Default number of neighbors is assumed to be 8.}
}
\description{
\code{makeAdjGrid()} produces a sparse representation of the adjacency structure for grid graphs, useful as the \code{adj} argument in \code{bcp()}.
}
\value{
\code{makeAdjGrid()} produces a list representation of the adjacency structure for grid graphs. The \eqn{i}-th entry in the list gives a vector of neighbor ids for the \eqn{i}-th node. Note that neighbor ids are offset by 1 because indexing starts at 0 in C++.
If \code{k = 8}, then we assume each node is joined via edges to its 8 neighbors in the (top left, top middle, top right, left, right, bottom left, bottom middle, and bottom right) directions, where applicable. If \code{k = 4}, then we assume each node is joined via edges to its 4 neighbors in the (top, right, bottom, left) directions, where applicable.
}
\examples{
# generates an adjacency list for a 10 node by 5 node grid, assuming a maximum of 8 neighbors
adj <- makeAdjGrid(10, 5) 

# generates an adjacency list for a 10 node by 5 node grid, assuming a maximum of 4 neighbors
adj4 <- makeAdjGrid(10, 5, 4)


### show a grid example
\donttest{

if (require("ggplot2")) {

  set.seed(5)
  adj <- makeAdjGrid(20)
  z   <- rep(c(0, 2), each=200)
  y   <- z + rnorm(400, sd=1)
  out <- bcp(y, adj=adj, burnin=500, mcmc=500)


  df  <- data.frame(mean=z, data = y, post.means = out$posterior.mean[,1], 
                   post.probs = out$posterior.prob, 
                   i = rep(1:20, each=20), j = rep(1:20, times=20))

  # visualize the data
  g <- ggplot(df, aes(i,j)) + 
         geom_tile(aes(fill = data), color='white') +
         scale_fill_gradientn(limits=range(y), colours=c('white', 'steelblue'))+
         ggtitle("Observed Data")
  print(g)

  # visualize the means
  g <- ggplot(df, aes(i,j)) + 
         geom_tile(aes(fill = mean), color='white') +
         scale_fill_gradientn(limits=range(y), colours=c('white', 'steelblue'))+
         ggtitle("True Means")
  print(g)

  # visualize the posterior means/probs
  g <- ggplot(df, aes(i,j)) + 
         geom_tile(aes(fill = post.means), color='white') +
         scale_fill_gradientn(limits=range(y), colours=c('white', 'steelblue'))+
         ggtitle("Posterior Means")
  print(g)

  g <- ggplot(df, aes(i,j)) + 
         geom_tile(aes(fill = post.probs), color='white') +
         scale_fill_gradientn(limits=c(0, 1), colours=c('white', 'steelblue'))+
         ggtitle("Posterior Boundary Probabilities")
  print(g)
}
}

}
\seealso{
\code{\link{bcp}} for performing Bayesian change point analysis.
}
\author{
Xiaofei Wang
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/output.R
\name{plot.bcp}
\alias{plot.bcp}
\title{Plotting Bayesian change point results}
\usage{
\method{plot}{bcp}(x, separated = FALSE, outer.margins = list(left =
  unit(4, "lines"), bottom = unit(3, "lines"), right = unit(2, "lines"),
  top = unit(2, "lines")), lower.area = unit(0.33, "npc"),
  size.points = unit(0.25, "char"), pch.points = 20, colors = NULL,
  main = NULL, xlab = NULL, xaxlab = NULL,
  cex.axes = list(cex.xaxis = 0.75, cex.yaxis.lower = 0.75,
  cex.yaxis.upper.default = 0.75, cex.yaxis.upper.separated = 0.5),
  lwd = 1, ...)
}
\arguments{
\item{x}{the result of a call to \code{bcp()}.}

\item{separated}{logical. If set to \code{TRUE} and the data is multivariate, each series is plotted separately.}

\item{outer.margins}{(optional) list of units specifying the left, bottom, right and top margins.  For more information on units, see the documentation for \code{grid}.}

\item{lower.area}{(optional) unit specifying the proportion of the plot occupied by the posterior probabilities of change points.}

\item{size.points}{(optional) unit specifying the size of the data points.}

\item{pch.points}{(optional) unit specifying the style of the data points.}

\item{colors}{(optional) vector specifying the colors in which to plot each data series.}

\item{main}{(optional) plot title. Use \code{""} for no title.}

\item{xlab}{(optional) a character string specifying the x-axis label. Defaults to "Location".}

\item{xaxlab}{(optional) a vector having length equal to the number of observations giving the x-axis tick labels. Defaults to the sequence from 1 to n.}

\item{cex.axes}{(optional) list specifying the sizes of the axes labels. \code{cex.xaxis} specifies the size of the x-axis label, \code{cex.yaxis.lower} specifies the size of the y-axis label of the posterior probability plot, \code{cex.yaxis.upper.default} specifies the size of the y-axis labels of the posterior means plot when the series are displayed in a single plot, and \code{cex.yaxis.upper.separated} specifies the size of the y-axis labels of the posterior means plots when each series is plotted separately.}

\item{lwd}{line width}

\item{...}{(optional) additional arguments, ignored.}
}
\description{
\code{plot.bcp()} produces summary plots of the results of \code{bcp()}. Currently, only the summary plots for serial data are implemented. 
If an adjacency structure (adj) is provided, then the data are assumed to reside on nodes of a general graph. Additional parameters are used in this graph change point model.
}
\details{
\code{plot.bcp()} produces the following plots using \code{grid} graphics instead of \code{base}:
  
 Posterior Means: location in the sequence versus the posterior means over the iterations. 

 Posterior Probability of a Change: location in the sequence versus the relative frequency of iterations which resulted in a change point.
}
\value{No return value, called for plotting the result}

\examples{
testdata <- cbind( c(rnorm(50), rnorm(50, -5, 1), rnorm(50)),
c(rnorm(50), rnorm(50, 10.8, 1), rnorm(50, -3, 1)) )
bcp.0 <- bcp(testdata)
plot(bcp.0, main="Multivariate (k=2) Change Point Example")
plot(bcp.0, separated=TRUE, main="Multivariate (k=2) Change Point Example")

}
\seealso{
\code{\link{legacyplot}}, \code{\link{bcp}}, \code{\link{summary.bcp}}, and \code{\link{print.bcp}} for complete results and summary statistics.
}
\author{
Xiaofei Wang, Chandra Erdman, and John W. Emerson
}
\keyword{datasets}
